unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,contnrs;

type
  TCharItem = class
    Char:Char;
    fgColor,bgColor:TColor;
    sel:Boolean;
    Tx,Ty,sx,sy:Integer;
  end;
  
  { TForm1 }

  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1Click(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X,Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
  private
    { private declarations }
  public
    CharItems:TObjectlist;
    buffer:TBitmap;
    
    oldSelCount,oldIndex,endindex,
    SelCount, // Speichert die Anzahl der makierten zeichnen
    SelFirstIndex:Integer; // Speichert den ersten Makirten Zeichen
    procedure AddStrToCharItems(str:String;fgColor, bgColor:TColor);
    function GetCharIndex(x,y:Integer):Integer;
    procedure SetSel(vEndIndex:Integer; Value:Boolean);
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

procedure TForm1.SetSel(vEndIndex:Integer; Value:Boolean);
var
  i,m:integer;
  
begin
  if EndIndex > -1 then begin
    if SelFirstIndex > -1 then
      m:=SelFirstIndex
    else
      m:=0;

    if m < vEndIndex then begin
      for i:=m to vEndIndex do begin
        TCharItem(CharItems[i]).sel:=Value;
      end;
    end
    else begin
      for i:=vEndIndex downTo m do begin
        TCharItem(CharItems[i]).sel:=Value;
      end;

    end;
  end;
end;

function TForm1.GetCharIndex(x,y:Integer):Integer;
var
  i,z,l:integer;
begin
  z:=-1;
  if SelFirstIndex > -1 then
    l:=SelFirstIndex
  else
    l:=0;
    
  for i:=l to CharItems.count-1 do begin
    with TCharItem(CharItems[i]) do begin
      if (x >= tx) and (x <= tx+sx) and
          (y >=Ty) and (y <=ty+sy) then begin
        z:=i;
        break;
      end;
    end;
  end;
  result:=z;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SelCount:=0; SelFirstIndex:=-1; oldSelCount:=-1;
  oldIndex:=-1; endIndex:=-1;
  buffer:=TBitmap.Create; CharItems:=TObjectList.Create;
  buffer.Width:=Paintbox1.Width; buffer.Height:=Paintbox1.Height;
  AddStrToCharItems('01: Dies ist ein Test von Heute',clRed,clBlack);
  AddStrToCharItems('02: Wie geht es dir so ?',clLime,clBlack);
  AddStrToCharItems('03: Heute ist aber ein schöner Tag oder ?',clBlack,clBlack);
  AddStrToCharItems('04: Morgen ist nicht Montag !',clOlive,clBlack);

//  AddStrToCharItems('05: ------------------------',clRed,clBlack);

  AddStrToCharItems('05: 60824660824686806465',clRed,clBlack);
  AddStrToCharItems('06: TestTestTestTest',clLime,clBlack);
  AddStrToCharItems('07: HalloHalloHallo Hallo',clBlack,clBlack);
  AddStrToCharItems('08: Der Wald ist rot',clOlive,clBlack);
end;

procedure TForm1.PaintBox1Click(Sender: TObject);
begin
  SelFirstIndex:=-1;
  SetSel(CharItems.Count-1,False);

end;

procedure TForm1.PaintBox1MouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X,Y: Integer);
begin
  SelFirstIndex:=GetCharIndex(x,y);
  SelCount:=0;
//  if SelFirstIndex > -1 then
//    Caption:=TCharItem(CharItems[SelFirstIndex]).Char
//  else
//    Caption:='!! = -1 !!';
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if [ssLeft] = Shift then begin
    if SelFirstIndex > -1 then begin
      if endindex > oldindex then
      oldIndex:=endindex;
      endindex:=GetCharIndex(x,y);

      if endindex > -1 then begin
        SetSel(oldindex,False);
        SetSel(endIndex,True);

      end;
      PaintBox1Paint(self);
    end;
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  i,px,py:Integer;
begin
  buffer.Canvas.FillRect(0,0,PaintBox1.Width,PaintBox1.Height);
  px:=0; py:=0;
  for i:=0 to CharItems.count-1 do begin
    with TCharItem(Charitems.items[i]) do begin

      ty:=py; tx:=px; sx:=buffer.canvas.TextWidth(Char); sy:=buffer.canvas.TextHeight(char)+5;

      if px >=buffer.Width then begin
        px:=0;
        inc(py,buffer.canvas.TextHeight(char)+5);
      end;

      if sel = True then begin
        buffer.canvas.Brush.Color:=clBlack;
        buffer.canvas.font.color:=clWhite;
        buffer.Canvas.FillRect(px,py,px+sx+3,py+sy);
      end
      else begin
        buffer.canvas.Brush.Color:=clWhite;
        buffer.canvas.font.Color:=fgColor;
      end;


      buffer.Canvas.TextOut(px,py,Char);
      inc(px, buffer.canvas.TextWidth(Char));

      
    end;
  end;
  
  PaintBox1.Canvas.CopyRect(rect(0,0,PaintBox1.Width,PaintBox1.Height),buffer.canvas,rect(0,0,PaintBox1.Width,PaintBox1.Height))
end;

procedure TForm1.AddStrToCharItems(str:String;fgColor, bgColor:TColor);
var
  charitem:TCharItem;
  x:Integer;
begin
  for x:=1 to Length(str) do begin
    charitem:=TCharItem.Create;
    charitem.Char:=str[x];
    charitem.fgColor:=fgColor;
    charitem.bgColor:=bgColor;
    CharItems.Add(charitem);

  end;
end;

initialization
  {$I Unit1.lrs}

end.

